
/* 
* Chris Mulhearn 
* 
* PSP serial port IO routines 
*/ 

// Chris Mulhearn\[`ȂłAIrDA|[gp
// AhXύXėpĂĂ܂B
// 2008/3/18 STEAR

#include <pspsdk.h>



/* instantiate "serialport" that points to psp remote control serial port */ 
/* 0xBE500000 remote control */
/* 0xBE540000 IrDA */

	/*
	
struct serialport { 
	int * txbuf; // tx + rx same on psp, 0xbe50 0000, bits 7..0 
	int * rxbuf; 
	int * status; 
	int * baudh;
	int * baudl;
	int * control;
#define serialport_txfull ((int)0x00000020) 
#define serialport_rxempty ((int)0x00000010) 
}; 
	
struct serialport psprc_serialport = 
{ 
	.txbuf = (int*)0xbe540000, 
	.rxbuf = (int*)0xbe540000, 
	.status = (int*)0xbe540018, 
	.baudh = (int*)0xBE540024,
	.baudl = (int*)0xBE540028,
	.control = (int*)0xBE54002C,
}; 
*/

#define serialport_txfull ((int)0x00000020) 
#define serialport_rxempty ((int)0x00000010) 


#define	SERIAL_PORT_TXBUF	*((int*)0xbe540000)
#define	SERIAL_PORT_RXBUF	*((char*)0xbe540000)
#define	SERIAL_PORT_STATUS	*((int*)0xbe540018)
#define	SERIAL_PORT_BAUDH	*((int*)0xBE540024)
#define	SERIAL_PORT_BAUDL	*((int*)0xBE540028)
#define	SERIAL_PORT_CONTROL	*((int*)0xBE54002C)

void serialport_setspeed( unsigned int baudrate)
{ 
	//int k1 = pspSdkSetK1(0);
	
	//struct serialport * port_p = &psprc_serialport;
	
	unsigned int x;
	
	SERIAL_PORT_BAUDH = (96000000 / baudrate) >> 6;
	SERIAL_PORT_BAUDL = (96000000 / baudrate) & 0x3f;
	
	x = SERIAL_PORT_CONTROL;
	SERIAL_PORT_CONTROL = x|0x00000006;
	
	//pspSdkSetK1(k1);
}

int serialport_write( unsigned char * buffer, int length, int timeout)
{ 
	//int k1 = pspSdkSetK1(0);
	
	//struct serialport * port_p = &psprc_serialport;
	int tcnt, bcnt;
	
	if(length <= 0)
	{
		//pspSdkSetK1(k1);
		return 0;
	}
	
	bcnt = 0;
	
	while(1)
	{
		tcnt = 0;
		
		while( (SERIAL_PORT_STATUS) & serialport_txfull)
		{ 
			tcnt++;
			
			if(tcnt > timeout) break;
		}
		
		if(tcnt > timeout) break;
		
		/*if(buffer[bcnt])*/ SERIAL_PORT_TXBUF = buffer[bcnt];
		/*else *(port->txbuf) = '.'; */
		
		bcnt++;
		
		if(bcnt == length) break;
	}
	
	//pspSdkSetK1(k1);
	
	return bcnt;
}

int serialport_read( unsigned char * buffer, int length, int timeout)
{ 
	//int k1 = pspSdkSetK1(0);
	
	//struct serialport * port_p = &psprc_serialport;
	int tcnt, bcnt;
	
	if(length <= 0)
	{
		//pspSdkSetK1(k1);
		return 0;
	}
	
	bcnt = 0;
	
	while(1)
	{
		tcnt = 0;
		
		while(( (SERIAL_PORT_STATUS) & serialport_rxempty))
		{
			tcnt++;
		
			if(tcnt > timeout) break;
		}
		
		if(tcnt > timeout) break;
		
		buffer[bcnt] = SERIAL_PORT_RXBUF;
		bcnt++;
		
		if(bcnt == length) break;
	}
	
	//pspSdkSetK1(k1);
	
	return bcnt;
}

